<template>
  <v-dialog v-model="showDialog" max-width="70vw" persistent>
    <v-card>
      <v-card-title class="headline text-break" v-if="item">
        {{ item.netobject }} claim resolution
      </v-card-title>
      <v-divider></v-divider>
      <v-card-text class="pt-6" v-if="item">
        <div
          v-if="showConflictsNotification"
          style="max-height:60vh;"
          class="d-flex flex-column overflow-y-auto"
        >
          <span class="font-weight-bold"
            >This netobject may conflict with following:
          </span>
          <div class="d-flex flex-column overflow-y-auto">
            <span v-for="(netItem, netIndex) in conflictedNetobjects" :key="netIndex">
              <span
                >Netobject:
                {{
                  netItem.asn
                    ? "AS" + netItem.asn
                    : netItem.address || netItem.fqdn || netItem.ripe_org_hdl
                }}</span
              >
              <span class="ml-2">State: {{ netItem.approval }}</span>
              <span class="ml-2">
                tenant(s):
                {{ netItem.tenants.map(t => t.name).join(", ") }}</span
              >
              <span v-if="netItem.organisation" class="ml-2"
                >Organisation: {{ netItem.organisation.name }}</span
              >
            </span>
          </div>
          <div class="d-flex flex-column overflow-y-auto">
            <span v-for="(ripeItem, ripeIndex) in conflictedRipeData" :key="ripeIndex">
              <span v-if="ripeItem.address && ripeItem.organisations">
                <span v-for="(orga, orgaIndex) in ripeItem.organisations" :key="orgaIndex">
                  <span>
                    RIPE-Object: {{ ripeItem.address }}
                  </span>
                  <span v-if="orga.name" class="ml-2"
                  >Organisation: {{ orga.name }}</span
                  >
                  <span v-if="ripeItem.import_time" class="ml-2"
                  >Import time: {{ ripeItem.import_time }}</span
                  >
                </span>
              </span>
              <span v-else
              >RIPE-Object:
                {{
                  ripeItem.asn
                      ? "AS" + ripeItem.asn
                      : ripeItem.ripe_org_hdl
                }}
                <span v-if="ripeItem.name" class="ml-2"
                >Organisation: {{ ripeItem.name }}</span
                >
                <span v-if="ripeItem.import_time" class="ml-2"
                >Import time: {{ ripeItem.import_time }}</span
                >
              </span>
            </span>
          </div>
        </div>
        <span
          class="mt-4"
          v-if="
            conflictedNetobjects &&
              !conflictedNetobjects.length &&
              item.network_id
          "
        >
        </span>
        <div v-if="item" class="text-body-2 mt-2">
          Please <span class="font-weight-bold">Approve/Deny</span> the claim
          for {{ item.netobject }} netobject
        </div>
      </v-card-text>
      <v-divider></v-divider>
      <v-card-actions>
        <v-text-field v-if="loading" loading disabled></v-text-field>
        <UIAlert
          v-if="!loading && hasRequestError"
          v-bind:isSuccessful="false"
          v-bind:message="$store.state.application.httpErrorMessage"
        />
        <v-spacer></v-spacer>
        <v-btn
          color="blue darken-1"
          text
          @click="
            $emit('child-object', {
              closeDialog: true,
              stateChanged: false
            })
          "
          >cancel</v-btn
        >
        <v-btn
          color="blue darken-1"
          text
          @click="
            processType = 'denied';
            sendState();
          "
          >Deny</v-btn
        >
        <v-btn
          color="blue darken-1"
          text
          @click="
            processType = 'approved';
            sendState();
          "
          >Approve</v-btn
        >
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import { HTTP } from "@/lib/http";
import { computed, defineAsyncComponent, onMounted, ref } from "vue";

const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);

const props = defineProps({
  //processType: String,
  item: Object
});
const emit = defineEmits(["child-object"]);
const showDialog = true;
const conflictedNetobjects = ref();
const conflictedRipeData = ref();
const showConflictsNotification = ref(false);
const establishRoute = item => {
  let route = "/organisations/" + item.organisation_id;
  switch (itemType.value) {
    case "asn":
      route += "/asns/" + item.asn_id;
      break;
    case "network":
      route += "/networks/" + item.network_id;

      break;
    case "fqdn":
      route += "/fqdns/" + item.fqdn_id;
      break;
    case "ripehandle":
      route += "/ripe_handles/" + item.ripe_org_hdl_id;
      break;
  }
  route += "/conflicts";
  return route;
};
const itemType = computed(() => {
  if (props.item) {
    const itemKeys = Object.keys(props.item);
    switch (true) {
      case itemKeys.includes("asn_id"):
        return "asn";
      case itemKeys.includes("network_id"):
        return "network";
      case itemKeys.includes("ripe_org_hdl_id"):
        return "ripehandle";
    }
  }
  return "fqdn";
});
const getConflicts = () => {
  HTTP.get(establishRoute(props.item)).then(response => {
    conflictedNetobjects.value = response.data.tuency;
    conflictedRipeData.value = response.data.ripe;
    if ((conflictedNetobjects.value && conflictedNetobjects.value.length) || (conflictedRipeData.value && conflictedRipeData.value.length )) {
      showConflictsNotification.value = true;
    }
  });
};
const processType = ref("");
onMounted(() => {
  getConflicts();
});
const loading = ref(false);
const hasRequestError = ref(false);
const sendState = () => {
  loading.value = true;
  HTTP.put(
    `/organisations/${props.item?.organisation_id}${
      itemType.value === "asn"
        ? "/asns/" + props.item?.asn_id
        : itemType.value === "network"
        ? "/networks/" + props.item?.network_id
        : itemType.value === "ripehandle"
        ? "/ripe_handles/" + props.item?.ripe_org_hdl_id
        : "/fqdns/" + props.item?.fqdn_id
    }`,
    {
      approval: processType.value
    }
  )
    .then(() => {
      loading.value = false;
      emit("child-object", { closeDialog: true, stateChanged: true });
    })
    .catch(() => {
      loading.value = false;
      hasRequestError.value = true;
    });
};
</script>
